// scale_maker.js: alter incoming notes to match a defined scale
//

inlets = 1;
outlets = 1;

var sm_chromatic 	= new Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
var sm_major 	= new Array(0, 0, 2, 2, 4, 5, 5, 7, 7, 9, 9, 11);
var sm_minor		= new Array(0, 0, 2, 3, 3, 5, 5, 7, 8, 8, 10, 10);
var sm_pentmajor	= new Array(0, 0, 2, 2, 4, 4, 4, 7, 7, 7, 9, 9);
var sm_pentminor	= new Array(0, 0, 0, 3, 3, 5, 5, 7, 7, 9, 9, 9);
var sm_diminished	= new Array(0, 0, 2, 3, 3, 5, 6, 6, 8, 9, 9, 11);
var sm_wholetone	= new Array(0, 0, 2, 2, 4, 4, 6, 6, 8, 8, 10, 10);

var sm_scale = 0;
var sm_octave = 0;
var sm_note = 0;
var sm_outnote = 0;
var sm_trans = 0;

function msg_int(i)
{
	var calcnote;

	if ((i<0) || (i>127))	return;

	sm_octave = Math.floor(i / 12);
	sm_note = i % 12;

	switch (sm_scale) {
	case 1:
		calcnote = sm_major[sm_note];
		break;
	case 2:
		calcnote = sm_minor[sm_note];
		break;
	case 3:
		calcnote = sm_pentmajor[sm_note];
		break;
	case 4:
		calcnote = sm_pentminor[sm_note];
		break;
	case 5:
		calcnote = sm_diminished[sm_note];
		break;
	case 6:
		calcnote = sm_wholetone[sm_note];
		break;
	default:
		calcnote = sm_note;
	}

	sm_outnote = Math.floor(12 * sm_octave) + calcnote;
	sm_outnote += sm_trans;
	sm_sendnote();
}

function key(t)
{
	post("t: ", 0);
	sm_trans = t;
}

function scale(i)
{
	sm_scale = i;
	if (sm_scale < 0)	sm_scale = 0;
	if (sm_scale > 6)	sm_scale = 0;
}

sm_sendnote.local = 1;
function sm_sendnote()
{
	outlet(0, "int", sm_outnote);
}